#!/bin/bash
packagename=$1
rm -rf ~/.kylin-ide-server/server && mkdir -p ~/.kylin-ide-server/server
tar -xf /tmp/$packagename -C ~/.kylin-ide-server/server
rm -rf /tmp/$packagename 
if grep -q 'kylin' /etc/os-release && command -v kysec_set >/dev/null 2>&1;then
    find  ~/.kylin-ide-server/server -name *.node -exec kysec_set -n exectl -v verified {} +;
    [ -f ~/.kylin-ide-server/server/node ] && kysec_set -n exectl -v verified ~/.kylin-ide-server/server/node;
    [ -d ~/.kylin-ide-server/server/bin ] && kysec_set -r -n exectl -v verified ~/.kylin-ide-server/server/bin;
fi