#!/bin/bash
#仅支持linux ，因为windows中脚本完全不一样重新写一个
current_user=$(whoami)
declare -A failedpids
test_http_server(){
    local _port=$1
    local url="https://localhost:$_port/version"
    curl -i -k "$url" 2>&1 |grep -q "200 OK"
}
find_ssh_port_forwarding_procs() {
  
    # 使用ps获取所有SSH进程，然后grep匹配-NL后面跟着的端口号 用uww有问题
    local out=$(ps -f -ww -u $current_user |grep -E 'ssh.*TL*'|grep -v grep |awk '{print $2}')
    if [ -z "$out" ];then
        return 1
    fi 
    for pid in $out;do
        # echo $pid
        local cmdline=$(cat /proc/$pid/cmdline |tr '\0' ' ' )
        local port=$(echo $cmdline |perl -ne 'if (/-TL\s*(\d+):/) {print "$1\n"}')
        test_http_server $port
        if [ $? -eq 0 ];then
            if [[ -v failedpids[$pid] ]];then
                unset failedpids[$pid]
                # echo "检查成功了，从arry删除">>/tmp/log.1
            fi
        else
            # echo "检测失败" >>/tmp/log.1 #循环多试几次才删，防止刚创建就删除是不是记录下，下次再检查又失败了就删除
            if [[ -v failedpids[$pid] ]];then
                #find
                kill -9 $pid
                unset failedpids[$pid]
                # echo "kill success and delete $pid">>/tmp/kylinweclient.log.1
            else
                #not found
                failedpids[$pid]=1
            fi
        
        fi
    done
    return 0
}
check_is_running(){
    my_pid=$$
    local out=$(ps -f -ww -u $current_user |grep -E 'kylinide_web_sshmonitor'|grep -v grep |grep -v "$my_pid" |awk '{print $2}')
    
    if [ -z "$out" ];then
        #没有进程存在
        return 0 
    fi 
    
    return 1 
}
check_is_running
if [ $? -eq 0 ];then
    while true;do
        find_ssh_port_forwarding_procs
        if [ $? -ne 0 ];then
            break
        fi
        sleep 300
    done
fi

