#!/bin/bash
#
# Copyright (c) 2011 The Chromium Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

# Let the wrapped binary know that it has been run through the wrapper.
#export CLIENT_APPER="`readlink -f "$0"`"
if command -v readlink > /dev/null 2>&1; then
	REAL_SCRIPT_PATH=$(readlink -f "$0" 2>/dev/null)
	if [[ -z "$REAL_SCRIPT_PATH" ]];then
		REAL_SCRIPT_PATH="$0"
	fi
else
	REAL_SCRIPT_PATH="$0"
fi

SCRIPT_DIR="$(dirname "$REAL_SCRIPT_PATH")"
cd "$SCRIPT_DIR" || exit
#$HERE="`dirname "$CLIENT_APPER"`"
#echo $HERE
if [ "$#" -gt 0 ];then
	arg=$1
	./kylin-ide-web-client $arg
else
	./kylin-ide-web-client &
fi

#./kylin-ide-web &
#exec -a "$0" "$HERE/KylinIDE-Web-Client" "$@"
